import random
import datetime

class MockEC2:

    # 'ImageId': 'ami-01234567890123456',

    @staticmethod
    def instance_ids():
        return (
            'i-061cef0d767349855',
            'i-01004fa5321e0306e',
            'i-0e95f05f2b6710a95',
            'i-0f866d7c1d0f1d85c'
        )

    @staticmethod
    def instance_types():
        return (
            'a1.medium',
            'a1.large',
            'a1.xlarge',
            'a1.2xlarge',
            'a1.4xlarge',
            'a1.metal',
            'c1.medium',
            'c1.xlarge',
            'c3.large',
            'c3.xlarge',
            'c3.2xlarge',
            'c3.4xlarge',
            'c3.8xlarge',
            'c4.large',
            'c4.xlarge',
            'c4.2xlarge',
            'c4.4xlarge',
            'c4.8xlarge',
            'c5.large',
            'c5.xlarge',
            'c5.2xlarge',
            'c5.4xlarge',
            'c5.9xlarge',
            'c5.12xlarge',
            'c5.18xlarge',
            'c5.24xlarge',
            'c5.metal',
            'c5a.large',
            'c5a.xlarge',
            'c5a.2xlarge',
            'c5a.4xlarge',
            'c5a.8xlarge',
            'c5a.12xlarge',
            'c5a.16xlarge',
            'c5a.24xlarge',
            'c5ad.large',
            'c5ad.xlarge',
            'c5ad.2xlarge',
            'c5ad.4xlarge',
            'c5ad.8xlarge',
            'c5ad.12xlarge',
            'c5ad.16xlarge',
            'c5ad.24xlarge',
            'c5d.large',
            'c5d.xlarge',
            'c5d.2xlarge',
            'c5d.4xlarge',
            'c5d.9xlarge',
            'c5d.12xlarge',
            'c5d.18xlarge',
            'c5d.24xlarge',
            'c5d.metal',
            'c5n.large',
            'c5n.xlarge',
            'c5n.2xlarge',
            'c5n.4xlarge',
            'c5n.9xlarge',
            'c5n.18xlarge',
            'c5n.metal',
            'c6g.medium',
            'c6g.large',
            'c6g.xlarge',
            'c6g.2xlarge',
            'c6g.4xlarge',
            'c6g.8xlarge',
            'c6g.12xlarge',
            'c6g.16xlarge',
            'c6g.metal',
            'c6gd.medium',
            'c6gd.large',
            'c6gd.xlarge',
            'c6gd.2xlarge',
            'c6gd.4xlarge',
            'c6gd.8xlarge',
            'c6gd.12xlarge',
            'c6gd.16xlarge',
            'c6gd.metal',
            'c6gn.medium',
            'c6gn.large',
            'c6gn.xlarge',
            'c6gn.2xlarge',
            'c6gn.4xlarge',
            'c6gn.8xlarge',
            'c6gn.12xlarge',
            'c6gn.16xlarge',
            'c6i.large',
            'c6i.xlarge',
            'c6i.2xlarge',
            'c6i.4xlarge',
            'c6i.8xlarge',
            'c6i.12xlarge',
            'c6i.16xlarge',
            'c6i.24xlarge',
            'c6i.32xlarge',
            'c6i.metal',
            'cc1.4xlarge',
            'cc2.8xlarge',
            'cg1.4xlarge',
            'cr1.8xlarge',
            'd2.xlarge',
            'd2.2xlarge',
            'd2.4xlarge',
            'd2.8xlarge',
            'd3.xlarge',
            'd3.2xlarge',
            'd3.4xlarge',
            'd3.8xlarge',
            'd3en.xlarge',
            'd3en.2xlarge',
            'd3en.4xlarge',
            'd3en.6xlarge',
            'd3en.8xlarge',
            'd3en.12xlarge',
            'dl1.24xlarge',
            'f1.2xlarge',
            'f1.4xlarge',
            'f1.16xlarge',
            'g2.2xlarge',
            'g2.8xlarge',
            'g3.4xlarge',
            'g3.8xlarge',
            'g3.16xlarge',
            'g3s.xlarge',
            'g4ad.xlarge',
            'g4ad.2xlarge',
            'g4ad.4xlarge',
            'g4ad.8xlarge',
            'g4ad.16xlarge',
            'g4dn.xlarge',
            'g4dn.2xlarge',
            'g4dn.4xlarge',
            'g4dn.8xlarge',
            'g4dn.12xlarge',
            'g4dn.16xlarge',
            'g4dn.metal',
            'g5.xlarge',
            'g5.2xlarge',
            'g5.4xlarge',
            'g5.8xlarge',
            'g5.12xlarge',
            'g5.16xlarge',
            'g5.24xlarge',
            'g5.48xlarge',
            'g5g.xlarge',
            'g5g.2xlarge',
            'g5g.4xlarge',
            'g5g.8xlarge',
            'g5g.16xlarge',
            'g5g.metal',
            'hi1.4xlarge',
            'hpc6a.48xlarge',
            'hs1.8xlarge',
            'h1.2xlarge',
            'h1.4xlarge',
            'h1.8xlarge',
            'h1.16xlarge',
            'i2.xlarge',
            'i2.2xlarge',
            'i2.4xlarge',
            'i2.8xlarge',
            'i3.large',
            'i3.xlarge',
            'i3.2xlarge',
            'i3.4xlarge',
            'i3.8xlarge',
            'i3.16xlarge',
            'i3.metal',
            'i3en.large',
            'i3en.xlarge',
            'i3en.2xlarge',
            'i3en.3xlarge',
            'i3en.6xlarge',
            'i3en.12xlarge',
            'i3en.24xlarge',
            'i3en.metal',
            'im4gn.large',
            'im4gn.xlarge',
            'im4gn.2xlarge',
            'im4gn.4xlarge',
            'im4gn.8xlarge',
            'im4gn.16xlarge',
            'inf1.xlarge',
            'inf1.2xlarge',
            'inf1.6xlarge',
            'inf1.24xlarge',
            'is4gen.medium',
            'is4gen.large',
            'is4gen.xlarge',
            'is4gen.2xlarge',
            'is4gen.4xlarge',
            'is4gen.8xlarge',
            'm1.small',
            'm1.medium',
            'm1.large',
            'm1.xlarge',
            'm2.xlarge',
            'm2.2xlarge',
            'm2.4xlarge',
            'm3.medium',
            'm3.large',
            'm3.xlarge',
            'm3.2xlarge',
            'm4.large',
            'm4.xlarge',
            'm4.2xlarge',
            'm4.4xlarge',
            'm4.10xlarge',
            'm4.16xlarge',
            'm5.large',
            'm5.xlarge',
            'm5.2xlarge',
            'm5.4xlarge',
            'm5.8xlarge',
            'm5.12xlarge',
            'm5.16xlarge',
            'm5.24xlarge',
            'm5.metal',
            'm5a.large',
            'm5a.xlarge',
            'm5a.2xlarge',
            'm5a.4xlarge',
            'm5a.8xlarge',
            'm5a.12xlarge',
            'm5a.16xlarge',
            'm5a.24xlarge',
            'm5ad.large',
            'm5ad.xlarge',
            'm5ad.2xlarge',
            'm5ad.4xlarge',
            'm5ad.8xlarge',
            'm5ad.12xlarge',
            'm5ad.16xlarge',
            'm5ad.24xlarge',
            'm5d.large',
            'm5d.xlarge',
            'm5d.2xlarge',
            'm5d.4xlarge',
            'm5d.8xlarge',
            'm5d.12xlarge',
            'm5d.16xlarge',
            'm5d.24xlarge',
            'm5d.metal',
            'm5dn.large',
            'm5dn.xlarge',
            'm5dn.2xlarge',
            'm5dn.4xlarge',
            'm5dn.8xlarge',
            'm5dn.12xlarge',
            'm5dn.16xlarge',
            'm5dn.24xlarge',
            'm5dn.metal',
            'm5n.large',
            'm5n.xlarge',
            'm5n.2xlarge',
            'm5n.4xlarge',
            'm5n.8xlarge',
            'm5n.12xlarge',
            'm5n.16xlarge',
            'm5n.24xlarge',
            'm5n.metal',
            'm5zn.large',
            'm5zn.xlarge',
            'm5zn.2xlarge',
            'm5zn.3xlarge',
            'm5zn.6xlarge',
            'm5zn.12xlarge',
            'm5zn.metal',
            'm6a.large',
            'm6a.xlarge',
            'm6a.2xlarge',
            'm6a.4xlarge',
            'm6a.8xlarge',
            'm6a.12xlarge',
            'm6a.16xlarge',
            'm6a.24xlarge',
            'm6a.32xlarge',
            'm6a.48xlarge',
            'm6g.metal',
            'm6g.medium',
            'm6g.large',
            'm6g.xlarge',
            'm6g.2xlarge',
            'm6g.4xlarge',
            'm6g.8xlarge',
            'm6g.12xlarge',
            'm6g.16xlarge',
            'm6gd.metal',
            'm6gd.medium',
            'm6gd.large',
            'm6gd.xlarge',
            'm6gd.2xlarge',
            'm6gd.4xlarge',
            'm6gd.8xlarge',
            'm6gd.12xlarge',
            'm6gd.16xlarge',
            'm6i.large',
            'm6i.xlarge',
            'm6i.2xlarge',
            'm6i.4xlarge',
            'm6i.8xlarge',
            'm6i.12xlarge',
            'm6i.16xlarge',
            'm6i.24xlarge',
            'm6i.32xlarge',
            'm6i.metal',
            'mac1.metal',
            'p2.xlarge',
            'p2.8xlarge',
            'p2.16xlarge',
            'p3.2xlarge',
            'p3.8xlarge',
            'p3.16xlarge',
            'p3dn.24xlarge',
            'p4d.24xlarge',
            'r3.large',
            'r3.xlarge',
            'r3.2xlarge',
            'r3.4xlarge',
            'r3.8xlarge',
            'r4.large',
            'r4.xlarge',
            'r4.2xlarge',
            'r4.4xlarge',
            'r4.8xlarge',
            'r4.16xlarge',
            'r5.large',
            'r5.xlarge',
            'r5.2xlarge',
            'r5.4xlarge',
            'r5.8xlarge',
            'r5.12xlarge',
            'r5.16xlarge',
            'r5.24xlarge',
            'r5.metal',
            'r5a.large',
            'r5a.xlarge',
            'r5a.2xlarge',
            'r5a.4xlarge',
            'r5a.8xlarge',
            'r5a.12xlarge',
            'r5a.16xlarge',
            'r5a.24xlarge',
            'r5ad.large',
            'r5ad.xlarge',
            'r5ad.2xlarge',
            'r5ad.4xlarge',
            'r5ad.8xlarge',
            'r5ad.12xlarge',
            'r5ad.16xlarge',
            'r5ad.24xlarge',
            'r5b.large',
            'r5b.xlarge',
            'r5b.2xlarge',
            'r5b.4xlarge',
            'r5b.8xlarge',
            'r5b.12xlarge',
            'r5b.16xlarge',
            'r5b.24xlarge',
            'r5b.metal',
            'r5d.large',
            'r5d.xlarge',
            'r5d.2xlarge',
            'r5d.4xlarge',
            'r5d.8xlarge',
            'r5d.12xlarge',
            'r5d.16xlarge',
            'r5d.24xlarge',
            'r5d.metal',
            'r5dn.large',
            'r5dn.xlarge',
            'r5dn.2xlarge',
            'r5dn.4xlarge',
            'r5dn.8xlarge',
            'r5dn.12xlarge',
            'r5dn.16xlarge',
            'r5dn.24xlarge',
            'r5dn.metal',
            'r5n.large',
            'r5n.xlarge',
            'r5n.2xlarge',
            'r5n.4xlarge',
            'r5n.8xlarge',
            'r5n.12xlarge',
            'r5n.16xlarge',
            'r5n.24xlarge',
            'r5n.metal',
            'r6g.medium',
            'r6g.large',
            'r6g.xlarge',
            'r6g.2xlarge',
            'r6g.4xlarge',
            'r6g.8xlarge',
            'r6g.12xlarge',
            'r6g.16xlarge',
            'r6g.metal',
            'r6gd.medium',
            'r6gd.large',
            'r6gd.xlarge',
            'r6gd.2xlarge',
            'r6gd.4xlarge',
            'r6gd.8xlarge',
            'r6gd.12xlarge',
            'r6gd.16xlarge',
            'r6gd.metal',
            'r6i.large',
            'r6i.xlarge',
            'r6i.2xlarge',
            'r6i.4xlarge',
            'r6i.8xlarge',
            'r6i.12xlarge',
            'r6i.16xlarge',
            'r6i.24xlarge',
            'r6i.32xlarge',
            'r6i.metal',
            't1.micro',
            't2.nano',
            't2.micro',
            't2.small',
            't2.medium',
            't2.large',
            't2.xlarge',
            't2.2xlarge',
            't3.nano',
            't3.micro',
            't3.small',
            't3.medium',
            't3.large',
            't3.xlarge',
            't3.2xlarge',
            't3a.nano',
            't3a.micro',
            't3a.small',
            't3a.medium',
            't3a.large',
            't3a.xlarge',
            't3a.2xlarge',
            't4g.nano',
            't4g.micro',
            't4g.small',
            't4g.medium',
            't4g.large',
            't4g.xlarge',
            't4g.2xlarge',
            'u-6tb1.56xlarge',
            'u-6tb1.112xlarge',
            'u-9tb1.112xlarge',
            'u-12tb1.112xlarge',
            'u-6tb1.metal',
            'u-9tb1.metal',
            'u-12tb1.metal',
            'u-18tb1.metal',
            'u-24tb1.metal',
            'vt1.3xlarge',
            'vt1.6xlarge',
            'vt1.24xlarge',
            'x1.16xlarge',
            'x1.32xlarge',
            'x1e.xlarge',
            'x1e.2xlarge',
            'x1e.4xlarge',
            'x1e.8xlarge',
            'x1e.16xlarge',
            'x1e.32xlarge',
            'x2iezn.2xlarge',
            'x2iezn.4xlarge',
            'x2iezn.6xlarge',
            'x2iezn.8xlarge',
            'x2iezn.12xlarge',
            'x2iezn.metal',
            'x2gd.medium',
            'x2gd.large',
            'x2gd.xlarge',
            'x2gd.2xlarge',
            'x2gd.4xlarge',
            'x2gd.8xlarge',
            'x2gd.12xlarge',
            'x2gd.16xlarge',
            'x2gd.metal',
            'z1d.large',
            'z1d.xlarge',
            'z1d.2xlarge',
            'z1d.3xlarge',
            'z1d.6xlarge',
            'z1d.12xlarge',
            'z1d.metal',
            'x2idn.16xlarge',
            'x2idn.24xlarge',
            'x2idn.32xlarge',
            'x2iedn.xlarge',
            'x2iedn.2xlarge',
            'x2iedn.4xlarge',
            'x2iedn.8xlarge',
            'x2iedn.16xlarge',
            'x2iedn.24xlarge',
            'x2iedn.32xlarge',
            'c6a.large',
            'c6a.xlarge',
            'c6a.2xlarge',
            'c6a.4xlarge',
            'c6a.8xlarge',
            'c6a.12xlarge',
            'c6a.16xlarge',
            'c6a.24xlarge',
            'c6a.32xlarge',
            'c6a.48xlarge',
            'c6a.metal',
            'm6a.metal',
            'i4i.large',
            'i4i.xlarge',
            'i4i.2xlarge',
            'i4i.4xlarge',
            'i4i.8xlarge',
            'i4i.16xlarge',
            'i4i.32xlarge',
            'i4i.metal',
            'x2idn.metal',
            'x2iedn.metal',
            'c7g.medium',
            'c7g.large',
            'c7g.xlarge',
            'c7g.2xlarge',
            'c7g.4xlarge',
            'c7g.8xlarge',
            'c7g.12xlarge',
            'c7g.16xlarge',
            'mac2.metal',
            'c6id.large',
            'c6id.xlarge',
            'c6id.2xlarge',
            'c6id.4xlarge',
            'c6id.8xlarge',
            'c6id.12xlarge',
            'c6id.16xlarge',
            'c6id.24xlarge',
            'c6id.32xlarge',
            'c6id.metal',
            'm6id.large',
            'm6id.xlarge',
            'm6id.2xlarge',
            'm6id.4xlarge',
            'm6id.8xlarge',
            'm6id.12xlarge',
            'm6id.16xlarge',
            'm6id.24xlarge',
            'm6id.32xlarge',
            'm6id.metal',
            'r6id.large',
            'r6id.xlarge',
            'r6id.2xlarge',
            'r6id.4xlarge',
            'r6id.8xlarge',
            'r6id.12xlarge',
            'r6id.16xlarge',
            'r6id.24xlarge',
            'r6id.32xlarge',
            'r6id.metal',
            'r6a.large',
            'r6a.xlarge',
            'r6a.2xlarge',
            'r6a.4xlarge',
            'r6a.8xlarge',
            'r6a.12xlarge',
            'r6a.16xlarge',
            'r6a.24xlarge',
            'r6a.32xlarge',
            'r6a.48xlarge',
            'r6a.metal',
            'p4de.24xlarge',
        )

    def reservation():
        return {
            'Groups': [
                {
                    'GroupName': 'string',
                    'GroupId': 'string'
                },
            ],
            'Instances': [
                {
                    'AmiLaunchIndex': 123,
                    'ImageId': 'string',
                    'InstanceId': 'string',
                    'InstanceType': random.choice(self.instance_types()),
                    'KernelId': 'string',
                    'KeyName': 'string',
                    'LaunchTime': datetime(2015, 1, 1),
                    'Monitoring': {
                        'State': 'disabled'|'disabling'|'enabled'|'pending'
                    },
                    'Placement': {
                        'AvailabilityZone': 'string',
                        'Affinity': 'string',
                        'GroupName': 'string',
                        'PartitionNumber': 123,
                        'HostId': 'string',
                        'Tenancy': 'default'|'dedicated'|'host',
                        'SpreadDomain': 'string',
                        'HostResourceGroupArn': 'string'
                    },
                    'Platform': 'Windows',
                    'PrivateDnsName': 'string',
                    'PrivateIpAddress': 'string',
                    'ProductCodes': [
                        {
                            'ProductCodeId': 'string',
                            'ProductCodeType': 'devpay'|'marketplace'
                        },
                    ],
                    'PublicDnsName': 'string',
                    'PublicIpAddress': 'string',
                    'RamdiskId': 'string',
                    'State': {
                        'Code': 123,
                        'Name': 'pending'|'running'|'shutting-down'|'terminated'|'stopping'|'stopped'
                    },
                    'StateTransitionReason': 'string',
                    'SubnetId': 'string',
                    'VpcId': 'string',
                    'Architecture': 'i386'|'x86_64'|'arm64'|'x86_64_mac',
                    'BlockDeviceMappings': [
                        {
                            'DeviceName': 'string',
                            'Ebs': {
                                'AttachTime': datetime(2015, 1, 1),
                                'DeleteOnTermination': True|False,
                                'Status': 'attaching'|'attached'|'detaching'|'detached',
                                'VolumeId': 'string'
                            }
                        },
                    ],
                    'ClientToken': 'string',
                    'EbsOptimized': True|False,
                    'EnaSupport': True|False,
                    'Hypervisor': 'ovm'|'xen',
                    'IamInstanceProfile': {
                        'Arn': 'string',
                        'Id': 'string'
                    },
                    'InstanceLifecycle': 'spot'|'scheduled',
                    'ElasticGpuAssociations': [
                        {
                            'ElasticGpuId': 'string',
                            'ElasticGpuAssociationId': 'string',
                            'ElasticGpuAssociationState': 'string',
                            'ElasticGpuAssociationTime': 'string'
                        },
                    ],
                    'ElasticInferenceAcceleratorAssociations': [
                        {
                            'ElasticInferenceAcceleratorArn': 'string',
                            'ElasticInferenceAcceleratorAssociationId': 'string',
                            'ElasticInferenceAcceleratorAssociationState': 'string',
                            'ElasticInferenceAcceleratorAssociationTime': datetime(2015, 1, 1)
                        },
                    ],
                    'NetworkInterfaces': [
                        {
                            'Association': {
                                'CarrierIp': 'string',
                                'CustomerOwnedIp': 'string',
                                'IpOwnerId': 'string',
                                'PublicDnsName': 'string',
                                'PublicIp': 'string'
                            },
                            'Attachment': {
                                'AttachTime': datetime(2015, 1, 1),
                                'AttachmentId': 'string',
                                'DeleteOnTermination': True|False,
                                'DeviceIndex': 123,
                                'Status': 'attaching'|'attached'|'detaching'|'detached',
                                'NetworkCardIndex': 123
                            },
                            'Description': 'string',
                            'Groups': [
                                {
                                    'GroupName': 'string',
                                    'GroupId': 'string'
                                },
                            ],
                            'Ipv6Addresses': [
                                {
                                    'Ipv6Address': 'string'
                                },
                            ],
                            'MacAddress': 'string',
                            'NetworkInterfaceId': 'string',
                            'OwnerId': 'string',
                            'PrivateDnsName': 'string',
                            'PrivateIpAddress': 'string',
                            'PrivateIpAddresses': [
                                {
                                    'Association': {
                                        'CarrierIp': 'string',
                                        'CustomerOwnedIp': 'string',
                                        'IpOwnerId': 'string',
                                        'PublicDnsName': 'string',
                                        'PublicIp': 'string'
                                    },
                                    'Primary': True|False,
                                    'PrivateDnsName': 'string',
                                    'PrivateIpAddress': 'string'
                                },
                            ],
                            'SourceDestCheck': True|False,
                            'Status': 'available'|'associated'|'attaching'|'in-use'|'detaching',
                            'SubnetId': 'string',
                            'VpcId': 'string',
                            'InterfaceType': 'string',
                            'Ipv4Prefixes': [
                                {
                                    'Ipv4Prefix': 'string'
                                },
                            ],
                            'Ipv6Prefixes': [
                                {
                                    'Ipv6Prefix': 'string'
                                },
                            ]
                        },
                    ],
                    'OutpostArn': 'string',
                    'RootDeviceName': 'string',
                    'RootDeviceType': 'ebs'|'instance-store',
                    'SecurityGroups': [
                        {
                            'GroupName': 'string',
                            'GroupId': 'string'
                        },
                    ],
                    'SourceDestCheck': True|False,
                    'SpotInstanceRequestId': 'string',
                    'SriovNetSupport': 'string',
                    'StateReason': {
                        'Code': 'string',
                        'Message': 'string'
                    },
                    'Tags': [
                        {
                            'Key': 'string',
                            'Value': 'string'
                        },
                    ],
                    'VirtualizationType': 'hvm'|'paravirtual',
                    'CpuOptions': {
                        'CoreCount': 123,
                        'ThreadsPerCore': 123
                    },
                    'CapacityReservationId': 'string',
                    'CapacityReservationSpecification': {
                        'CapacityReservationPreference': 'open'|'none',
                        'CapacityReservationTarget': {
                            'CapacityReservationId': 'string',
                            'CapacityReservationResourceGroupArn': 'string'
                        }
                    },
                    'HibernationOptions': {
                        'Configured': True|False
                    },
                    'Licenses': [
                        {
                            'LicenseConfigurationArn': 'string'
                        },
                    ],
                    'MetadataOptions': {
                        'State': 'pending'|'applied',
                        'HttpTokens': 'optional'|'required',
                        'HttpPutResponseHopLimit': 123,
                        'HttpEndpoint': 'disabled'|'enabled',
                        'HttpProtocolIpv6': 'disabled'|'enabled',
                        'InstanceMetadataTags': 'disabled'|'enabled'
                    },
                    'EnclaveOptions': {
                        'Enabled': True|False
                    },
                    'BootMode': 'legacy-bios'|'uefi',
                    'PlatformDetails': 'string',
                    'UsageOperation': 'string',
                    'UsageOperationUpdateTime': datetime(2015, 1, 1),
                    'PrivateDnsNameOptions': {
                        'HostnameType': 'ip-name'|'resource-name',
                        'EnableResourceNameDnsARecord': True|False,
                        'EnableResourceNameDnsAAAARecord': True|False
                    },
                    'Ipv6Address': 'string',
                    'TpmSupport': 'string',
                    'MaintenanceOptions': {
                        'AutoRecovery': 'disabled'|'default'
                    }
                },
            ],
            'OwnerId': 'string',
            'RequesterId': 'string',
            'ReservationId': 'string'
        }

    @staticmethod
    def describe_instances():
        return {
            'Reservations': [
                {
                    'Groups': [],
                    'Instances': [
                        {
                            'AmiLaunchIndex': 0,
                            'ImageId': 'ami-01234567890123456',
                            'InstanceId': 'i-061cef0d767349855',
                            'InstanceType': 'm4.2xlarge',
                            'KeyName': 'KeyName',
                            'LaunchTime': datetime.datetime(2020, 8, 15, 0, 4, 39, tzinfo=datetime.timezone.utc),
                            'Monitoring': {'State': 'disabled'},
                            'Placement': {'AvailabilityZone': 'us-west-2a',
                                'GroupName': '',
                                'Tenancy': 'default'
                            },
                            'Platform': 'windows',
                            'PrivateDnsName': 'ip-10-182-252-231.us-west-2.compute.internal',
                            'PrivateIpAddress': '10.182.252.231',
                            'ProductCodes': [],
                            'PublicDnsName': '',
                            'State': {'Code': 16, 'Name': 'running'},
                            'StateTransitionReason': '',
                            'SubnetId': 'subnet-0df50d6f72cad8140',
                            'VpcId': 'vpc-0025c7eb2ebad4f1e',
                            'Architecture': 'x86_64',
                            'BlockDeviceMappings': [
                                {
                                    'DeviceName': '/dev/sda1',
                                    'Ebs': {
                                        'AttachTime': datetime.datetime(2018, 11, 13, 19, 14, 40, tzinfo=datetime.timezone.utc),
                                        'DeleteOnTermination': True,
                                        'Status': 'attached',
                                        'VolumeId': 'vol-067cb9c4c0440b8a3'
                                    }
                                },
                                {
                                    'DeviceName': 'xvdf',
                                    'Ebs': {
                                        'AttachTime': datetime.datetime(2018, 12, 14, 20, 4, 48, tzinfo=datetime.timezone.utc),
                                        'DeleteOnTermination': False,
                                        'Status': 'attached',
                                        'VolumeId': 'vol-0c3636a84b13b3b90'
                                    }
                                }
                            ],
                            'ClientToken': '',
                            'EbsOptimized': True,
                            'EnaSupport': True,
                            'Hypervisor': 'xen',
                            'IamInstanceProfile': {
                                'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDINFAGT01',
                                'Id': 'AIPA5BKAMRUXDQNC3X6DL'
                            },
                            'NetworkInterfaces': [
                                {
                                    'Attachment': {
                                        'AttachTime': datetime.datetime(2018, 11, 13, 19, 14, 39, tzinfo=datetime.timezone.utc),
                                        'AttachmentId': 'eni-attach-0d4c54fe1a60d9e67',
                                        'DeleteOnTermination': True,
                                        'DeviceIndex': 0,
                                        'Status': 'attached',
                                        'NetworkCardIndex': 0
                                    },
                                    'Description': 'Primary network interface',
                                    'Groups': [{
                                        'GroupName': 'launch-wizard-8',
                                        'GroupId': 'sg-05b254c5343551584'
                                    }],
                                    'Ipv6Addresses': [],
                                    'MacAddress': '06:2f:5f:23:3e:88',
                                    'NetworkInterfaceId': 'eni-0987cf07de64b4385',
                                    'OwnerId': '896172592430',
                                    'PrivateDnsName': 'ip-10-182-252-231.us-west-2.compute.internal',
                                    'PrivateIpAddress': '10.182.252.231',
                                    'PrivateIpAddresses': [{
                                        'Primary': True,
                                        'PrivateDnsName': 'ip-10-182-252-231.us-west-2.compute.internal',
                                        'PrivateIpAddress': '10.182.252.231'
                                    }],
                                    'SourceDestCheck': True,
                                    'Status': 'in-use',
                                    'SubnetId': 'subnet-0df50d6f72cad8140',
                                    'VpcId': 'vpc-0025c7eb2ebad4f1e',
                                    'InterfaceType': 'interface'
                                }
                            ],
                            'RootDeviceName': '/dev/sda1',
                            'RootDeviceType': 'ebs',
                            'SecurityGroups': [{'GroupName': 'launch-wizard-8',
                            'GroupId': 'sg-05b254c5343551584'}],
                            'SourceDestCheck': True,
                            'Tags': [
                                {'Key': 'ProjectName', 'Value': 'CDM'},
                                {'Key': 'awsbackup', 'Value': 'Dev'},
                                {'Key': 'CostTracking', 'Value': 'CDM'},
                                {'Key': 'Name', 'Value': 'AWTCDMDINFAGT01'}
                            ],
                            'VirtualizationType': 'hvm',
                            'CpuOptions': {'CoreCount': 4, 'ThreadsPerCore': 2},
                            'CapacityReservationSpecification': {
                                'CapacityReservationPreference': 'open'
                            },
                            'HibernationOptions': {'Configured': False},
                            'MetadataOptions': {
                                'State': 'applied',
                                'HttpTokens': 'optional',
                                'HttpPutResponseHopLimit': 1,
                                'HttpEndpoint': 'enabled'
                            },
                            'EnclaveOptions': {'Enabled': False}}],
                            'OwnerId': '896172592430',
                            'ReservationId': 'r-0e8b8b77d929239cb'
                        },
            {
                'Groups': [],
                'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-0364fe7a551bcfd56',
            'InstanceId': 'i-01004fa5321e0306e',
            'InstanceType': 't3.medium',
            'KeyName': 'ec2winwb',
            'LaunchTime': datetime.datetime(2020, 4, 14, 19, 17, 19, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2a',
            'GroupName': '',
            'Tenancy': 'default'},
            'PrivateDnsName': 'ip-10-182-252-163.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.252.163',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0df50d6f72cad8140',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/xvda',
            'Ebs': {'AttachTime': datetime.datetime(2020, 4, 14, 19, 17, 20, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0f6fa94eae64db2df'}}],
            'ClientToken': '2925c5e8-7f40-45b4-f703-56f5aa997c4a',
            'EbsOptimized': False,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/elasticbeanstalk-ec2-role',
            'Id': 'AIPAIG7CAOHCVDXIVZUGS'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 4, 14, 19, 17, 19, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0bbf5b15799f426fb',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'awseb-e-qqfskxzehg-stack-AWSEBSecurityGroup-VZEHYNHI9KYT',
                'GroupId': 'sg-00b9ef17ce591940d'}],
            'Ipv6Addresses': [],
            'MacAddress': '06:14:c7:32:aa:66',
            'NetworkInterfaceId': 'eni-09c964c659c7991ad',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-252-163.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.252.163',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-252-163.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.252.163'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0df50d6f72cad8140',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/xvda',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'awseb-e-qqfskxzehg-stack-AWSEBSecurityGroup-VZEHYNHI9KYT',
            'GroupId': 'sg-00b9ef17ce591940d'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'elasticbeanstalk:environment-id',
            'Value': 'e-qqfskxzehg'},
            {'Key': 'elasticbeanstalk:environment-name', 'Value': 'Cdmwebdev-env'},
            {'Key': 'aws:autoscaling:groupName',
            'Value': 'awseb-e-qqfskxzehg-stack-AWSEBAutoScalingGroup-1OY18FOOWYHDY'},
            {'Key': 'aws:cloudformation:stack-name',
            'Value': 'awseb-e-qqfskxzehg-stack'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Name', 'Value': 'Cdmwebdev-env'},
            {'Key': 'aws:cloudformation:logical-id',
            'Value': 'AWSEBAutoScalingGroup'},
            {'Key': 'aws:cloudformation:stack-id',
            'Value': 'arn:aws:cloudformation:us-west-2:896172592430:stack/awseb-e-qqfskxzehg-stack/d3b94590-5e84-11ea-b824-0ad20430b590'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'RequesterId': '903220451833',
        'ReservationId': 'r-04d01af7c2963273b'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-0bfb5de21f655d4d3',
            'InstanceId': 'i-0e95f05f2b6710a95',
            'InstanceType': 'm4.xlarge',
            'KeyName': 'ec2winwb',
            'LaunchTime': datetime.datetime(2019, 8, 2, 16, 35, 47, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-52.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.52',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 80, 'Name': 'stopped'},
            'StateTransitionReason': 'User initiated (2019-10-01 17:19:55 GMT)',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 6, 12, 19, 28, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': False,
                'Status': 'attached',
                'VolumeId': 'vol-0b35b69f977721fb0'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AmazonSSMRoleForInstancesQuickSetup',
            'Id': 'AIPA5BKAMRUXBPUL253LL'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 3, 20, 18, 56, 58, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-049b4bdef04a11430',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:74:71:43:0f:e8',
            'NetworkInterfaceId': 'eni-0938222de0bb51abc',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-52.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.52',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-52.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.52'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'StateReason': {'Code': 'Client.UserInitiatedShutdown',
            'Message': 'Client.UserInitiatedShutdown: User initiated shutdown'},
            'Tags': [{'Key': 'Name', 'Value': 'Goldenimage'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 2, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-040c2a51ac58e655e'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-070a9ba1ce367f47a',
            'InstanceId': 'i-00c7994cbb0f5aac2',
            'InstanceType': 't3.medium',
            'KeyName': 'ec2winwb',
            'LaunchTime': datetime.datetime(2020, 4, 15, 18, 7, 20, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-101.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.101',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 4, 17, 19, 4, 54, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0a743f71cb16d907c'}},
            {'DeviceName': 'xvdf',
            'Ebs': {'AttachTime': datetime.datetime(2019, 5, 13, 15, 14, 2, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': False,
                'Status': 'attached',
                'VolumeId': 'vol-0dbf25a45144d8865'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBox',
            'Id': 'AIPAJWECFSXYYD3VNDJKI'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 4, 17, 19, 4, 53, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-091fc4fc7b12b807a',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:d1:d2:26:37:14',
            'NetworkInterfaceId': 'eni-0f8bfab4d29ca75e1',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-101.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.101',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-101.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.101'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX02'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'Test2'},
            {'Key': 'User', 'Value': ''}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0455fa8f9dcdc859c'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-0ca88e94443ae00f9',
            'InstanceId': 'i-0f866d7c1d0f1d85c',
            'InstanceType': 't3.medium',
            'KeyName': 'ec2winwb',
            'LaunchTime': datetime.datetime(2021, 5, 7, 13, 35, 27, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-133.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.133',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 5, 6, 17, 49, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0803786b6047767df'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBox',
            'Id': 'AIPAJWECFSXYYD3VNDJKI'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 5, 6, 17, 49, 17, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0b40872a3773995e6',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:cd:1d:69:d5:54',
            'NetworkInterfaceId': 'eni-07ac7f37bbb9ac6c4',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-133.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.133',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-133.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.133'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX03'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'project', 'Value': 'cdm'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0ff3a8f6397223b01'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-0db3308f5de46e515',
            'InstanceId': 'i-00f6e6eedb381ae2b',
            'InstanceType': 't3.small',
            'KeyName': 'ec2winwb',
            'LaunchTime': datetime.datetime(2020, 12, 16, 23, 44, 57, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-95.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.95',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 6, 27, 14, 41, 45, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0ee73b7a7ee64d2a5'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBoxDatalakeDeveloper',
            'Id': 'AIPA5BKAMRUXEBZXRAK7U'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 6, 27, 14, 41, 44, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-082e01647a5eae7fb',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:44:50:e6:f7:b2',
            'NetworkInterfaceId': 'eni-014d6550403e16919',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-95.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.95',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-95.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.95'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX04'},
            {'Key': 'CostTracking', 'Value': 'CDM'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-002477b87a1e7b5e3'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-0db3308f5de46e515',
            'InstanceId': 'i-0bd2826d78115aa06',
            'InstanceType': 't3.small',
            'KeyName': 'ec2winwb',
            'LaunchTime': datetime.datetime(2020, 9, 10, 14, 55, 41, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-109.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.109',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 6, 27, 14, 43, 4, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0c01a2250ab493643'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBoxDatalakeDeveloper',
            'Id': 'AIPA5BKAMRUXEBZXRAK7U'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 6, 27, 14, 43, 3, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0e951bc23666d5a6b',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:22:bb:5a:95:c2',
            'NetworkInterfaceId': 'eni-0fc47c1c36ca2009e',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-109.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.109',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-109.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.109'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX05'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 1,
            'ImageId': 'ami-0db3308f5de46e515',
            'InstanceId': 'i-0f52a8926ade1bb5f',
            'InstanceType': 't3.medium',
            'KeyName': 'ec2winwb',
            'LaunchTime': datetime.datetime(2021, 4, 15, 14, 40, 42, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-132.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.132',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 6, 27, 14, 43, 4, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0d444f76bb318883f'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBoxDatalakeDeveloper',
            'Id': 'AIPA5BKAMRUXEBZXRAK7U'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 6, 27, 14, 43, 3, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0ff25dca7f8bd5a19',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:ec:b2:ef:a4:d4',
            'NetworkInterfaceId': 'eni-05c9736cbbb3b2bc8',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-132.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.132',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-132.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.132'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX06'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0f08eafac894a7167'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0b2f5d0c641e4be15',
            'InstanceType': 't3.medium',
            'KeyName': 'ec2winwb',
            'LaunchTime': datetime.datetime(2021, 5, 7, 13, 32, 43, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-188.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.188',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 8, 22, 17, 40, 44, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0604660fff2224b54'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX07Role',
            'Id': 'AIPA5BKAMRUXKPBUZ7H6R'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 8, 22, 17, 40, 43, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0457298938754a030',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:64:22:47:40:60',
            'NetworkInterfaceId': 'eni-0e4b797759bbae9d8',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-188.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.188',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-188.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.188'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'For Harry'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX07'},
            {'Key': 'ProjectName', 'Value': 'CDM'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0e4548e0092bfaf80'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-02612d526b5467284',
            'InstanceType': 't3.large',
            'KeyName': 'ec2winwb',
            'LaunchTime': datetime.datetime(2020, 11, 5, 16, 15, 2, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'enabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-58.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.58',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 10, 2, 19, 0, 58, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0540fe1b70e157c13'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBoxDataLakeRO_IIT',
            'Id': 'AIPA5BKAMRUXHGJYM6ZZZ'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 10, 2, 19, 0, 56, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-09153d9c159f982f7',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:55:de:ac:02:b8',
            'NetworkInterfaceId': 'eni-0919212ac26637587',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-58.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.58',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-58.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.58'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'ProjectName', 'Value': 'CDM'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX08'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'For Mike and Chip'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0f5db66803e47046c'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 1,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-0aab0967efe003792',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2019, 10, 29, 20, 8, 44, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'enabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-67.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.67',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 10, 17, 17, 58, 20, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-04427d8081bf38d92'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBox_Aurora_SOAR',
            'Id': 'AIPA5BKAMRUXM2JN3UFFV'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 10, 17, 17, 58, 19, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0e32c2e606be26db6',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:0c:e3:2c:32:c4',
            'NetworkInterfaceId': 'eni-0aa75ccb18da67d42',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-67.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.67',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-67.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.67'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Description', 'Value': 'Jumpbox for Aurora SOAR data access'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX13'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'ProjectName', 'Value': 'CDM'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 0,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-0bd4b8bb14e73053c',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2019, 10, 29, 20, 8, 39, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'enabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-233.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.233',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2019, 10, 17, 17, 58, 20, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-024a2b75ce3192686'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX12Role',
            'Id': 'AIPA5BKAMRUXAAS42YS5C'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2019, 10, 17, 17, 58, 19, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-07499ab6a81f872e8',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:bb:f0:14:42:e8',
            'NetworkInterfaceId': 'eni-0d78539484980c104',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-233.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.233',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-233.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.233'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'ProjectName', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX12'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Description', 'Value': 'Jumpbox for Aurora SOAR data access'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0a6b49528509bf3a8'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0cdb561958acffa4e',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 5, 7, 13, 38, 27, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-98.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.98',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 1, 22, 14, 40, 27, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0de977cb50bdd1c52'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX15Role',
            'Id': 'AIPA5BKAMRUXLXM3QVJ6B'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 1, 22, 14, 40, 26, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-02127f9fe3233925b',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:d3:7d:d2:38:52',
            'NetworkInterfaceId': 'eni-0a8a44d5531be6b51',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-98.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.98',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-98.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.98'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'ProjectName', 'Value': 'MobiusConversion'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX15'},
            {'Key': 'Description', 'Value': 'Jumpbox for BI Team'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0ffd9e64bc409ae39'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0548e8e706c79001c',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 5, 7, 13, 41, 20, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-202.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.202',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 1, 22, 22, 24, 2, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0336ed94676bd994c'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBoxDataLakeBIDev_role',
            'Id': 'AIPA5BKAMRUXFSGLWFJP6'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 1, 22, 22, 24, 1, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-02bebf7faf576668a',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:30:0b:e0:98:82',
            'NetworkInterfaceId': 'eni-06cbe3ee4fdffb245',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-202.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.202',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-202.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.202'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX17'},
            {'Key': 'ProjectName', 'Value': 'MobiusConversion'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'Jumpbox for BI Team'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 1,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0c4e159150504fb30',
            'InstanceType': 'm5.large',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 1, 28, 22, 54, 58, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-210.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.210',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 1, 22, 22, 24, 2, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0a1c5f5a2f31c52b0'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBoxDataLakeBIDev_role',
            'Id': 'AIPA5BKAMRUXFSGLWFJP6'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 1, 22, 22, 24, 1, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-085294db0023c468c',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:2a:8c:86:7d:ee',
            'NetworkInterfaceId': 'eni-07e19d361c61f4cf1',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-210.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.210',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-210.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.210'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Description', 'Value': 'Jumpbox for BI Team'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX16'},
            {'Key': 'ProjectName', 'Value': 'MobiusConversion'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0b9373c388e2fd121'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-01be8f607d5ea7b33',
            'InstanceType': 'm5.large',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 2, 12, 20, 59, 2, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-219.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.219',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 2, 12, 20, 59, 2, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0e9ed67ec72e17e80'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBox_PAS_ODS_Role',
            'Id': 'AIPA5BKAMRUXKSOT4FADT'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 2, 12, 20, 59, 2, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0001a9f25539cc74e',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:19:42:9c:93:5c',
            'NetworkInterfaceId': 'eni-0eadf842c28c38586',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-219.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.219',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-219.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.219'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX18'},
            {'Key': 'ProjectName', 'Value': 'PAS'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Description', 'Value': 'Jumpbox for PAS Datalake'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 1,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-045f9b9c7b07d2a66',
            'InstanceType': 'm5.large',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 4, 14, 20, 42, 6, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-222.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.222',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 2, 12, 20, 59, 2, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0177179f20ba88a0a'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJumpBox_PAS_ODS_Role',
            'Id': 'AIPA5BKAMRUXKSOT4FADT'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 2, 12, 20, 59, 2, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-057837f112c0fd6bf',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:ae:53:2b:60:e0',
            'NetworkInterfaceId': 'eni-06087b027c1a3a48e',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-222.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.222',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-222.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.222'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Description', 'Value': 'Jumpbox for PAS Datalake'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX19'},
            {'Key': 'ProjectName', 'Value': 'PAS'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0f47bc5b67897e809'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-016aef7101e2a7fb1',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 3, 6, 15, 1, 52, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-135.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.135',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 3, 6, 15, 1, 53, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0e91888bb8ebae7ad'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJmpBox21Role',
            'Id': 'AIPA5BKAMRUXN5Y2LNFLD'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 3, 6, 15, 1, 52, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-08add338cf542e249',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:c5:e1:42:98:84',
            'NetworkInterfaceId': 'eni-07750fd9e3ee01442',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-135.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.135',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-135.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.135'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'ProjectName', 'Value': 'SFDC'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Description', 'Value': 'BI Team - Data Services'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX21'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0a88f2e0561b631d5'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-077a3b983aae56e0f',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 3, 12, 16, 22, 46, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-68.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.68',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 3, 12, 16, 22, 47, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0aedf724befa867c8'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJmpBox22RoleNew',
            'Id': 'AIPA5BKAMRUXGOBIWQS3U'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 3, 12, 16, 22, 46, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0b5d8aaea0931123a',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:a6:fd:3e:39:ac',
            'NetworkInterfaceId': 'eni-03e391ff2bb184c09',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-68.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.68',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-68.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.68'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'ProjectName', 'Value': 'SFDC'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'QA Team'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX22'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0cbe8214f87123719'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 2,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-0c8838edd70547e01',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 3, 13, 19, 40, 17, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-175.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.175',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 28, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-07c7b2c333d0b45e8'}}],
            'ClientToken': '',
            'EbsOptimized': False,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJmpBox25Role',
            'Id': 'AIPA5BKAMRUXPYUSCZT53'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 27, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0b43ed26ae4c80967',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:91:3f:44:07:a2',
            'NetworkInterfaceId': 'eni-0bba6f27ca8696a7e',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-175.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.175',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-175.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.175'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'ProjectName', 'Value': 'SFDC'},
            {'Key': 'aws:ec2launchtemplate:id', 'Value': 'lt-034b79e1d9ccd7588'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX25'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'aws:ec2launchtemplate:version', 'Value': '1'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 1,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-0fb104b896438dffd',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 3, 13, 19, 33, 27, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-159.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.159',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 28, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0abc18e02852286f3'}}],
            'ClientToken': '',
            'EbsOptimized': False,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJmpBox24Role',
            'Id': 'AIPA5BKAMRUXETDIW3IYH'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 27, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-06ac14bb6d9cda142',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:02:b4:8a:75:a0',
            'NetworkInterfaceId': 'eni-0417580bbc947a8c6',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-159.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.159',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-159.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.159'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'aws:ec2launchtemplate:id', 'Value': 'lt-034b79e1d9ccd7588'},
            {'Key': 'ProjectName', 'Value': 'SFDC'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX24'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'aws:ec2launchtemplate:version', 'Value': '1'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 4,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-0f93018f79fc936a6',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 3, 12, 20, 54, 27, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-102.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.102',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 27, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-054d0ff462479f711'}}],
            'ClientToken': '',
            'EbsOptimized': False,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJmpBox23Role',
            'Id': 'AIPA5BKAMRUXGLDEM5TZU'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 27, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-06f2ed45eae605f45',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:14:70:3e:f7:18',
            'NetworkInterfaceId': 'eni-0db24560407626900',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-102.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.102',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-102.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.102'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'aws:ec2launchtemplate:version', 'Value': '1'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'aws:ec2launchtemplate:id', 'Value': 'lt-034b79e1d9ccd7588'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX23'},
            {'Key': 'ProjectName', 'Value': 'SFDC'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Group', 'Value': 'JMP'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 3,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-09dd898ba6d65dc37',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 3, 13, 21, 24, 13, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-115.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.115',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 27, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0b231758571e62c12'}}],
            'ClientToken': '',
            'EbsOptimized': False,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJmpBox27Role',
            'Id': 'AIPA5BKAMRUXB2CENHJWS'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 27, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0401f1a747b635fb6',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:99:99:48:9c:02',
            'NetworkInterfaceId': 'eni-01ef3eccdf234fae5',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-115.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.115',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-115.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.115'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'ProjectName', 'Value': 'SFDC'},
            {'Key': 'aws:ec2launchtemplate:id', 'Value': 'lt-034b79e1d9ccd7588'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX27'},
            {'Key': 'aws:ec2launchtemplate:version', 'Value': '1'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 0,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-0bd3f532d51108b76',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 3, 13, 20, 4, 32, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-57.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.57',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 27, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0087157c391ad7876'}}],
            'ClientToken': '',
            'EbsOptimized': False,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJmpBox26Role',
            'Id': 'AIPA5BKAMRUXGV33IK54C'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 3, 12, 20, 54, 27, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0530cf1fd158c5469',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:5a:66:b1:7a:d2',
            'NetworkInterfaceId': 'eni-04f3878bbdb8c85c8',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-57.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.57',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-57.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.57'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX26'},
            {'Key': 'ProjectName', 'Value': 'SFDC'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'aws:ec2launchtemplate:id', 'Value': 'lt-034b79e1d9ccd7588'},
            {'Key': 'aws:ec2launchtemplate:version', 'Value': '1'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Group', 'Value': 'JMP'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0218abc98bdfb4fcc'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-0c82013d1b2cfb3a6',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 3, 16, 17, 43, 43, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-50.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.50',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 3, 16, 14, 58, 12, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-05d62f47b3458a792'}}],
            'ClientToken': '',
            'EbsOptimized': False,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJmpBox28Role',
            'Id': 'AIPA5BKAMRUXCMPCZRNKV'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 3, 16, 14, 58, 12, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-09b268b97b2d9d564',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:53:36:df:bb:28',
            'NetworkInterfaceId': 'eni-0d9411c74d65f6b19',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-50.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.50',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-50.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.50'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'ProjectName', 'Value': 'SFDC'},
            {'Key': 'aws:ec2launchtemplate:id', 'Value': 'lt-034b79e1d9ccd7588'},
            {'Key': 'aws:ec2launchtemplate:version', 'Value': '1'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX28'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-001a999075bfb17c6'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-037cc4566afa15e67',
            'InstanceId': 'i-07b313ced71fd94ca',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 3, 17, 13, 34, 17, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-74.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.74',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 3, 17, 13, 34, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-082808a94ab2fc842'}}],
            'ClientToken': '',
            'EbsOptimized': False,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/CdmJmpBox29Role',
            'Id': 'AIPA5BKAMRUXJM744UYD4'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 3, 17, 13, 34, 17, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-08b2c5e94bc730568',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:6c:7e:f8:bb:46',
            'NetworkInterfaceId': 'eni-05562858411ee9bbd',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-74.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.74',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-74.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.74'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX29'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'aws:ec2launchtemplate:version', 'Value': '1'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'aws:ec2launchtemplate:id', 'Value': 'lt-034b79e1d9ccd7588'},
            {'Key': 'ProjectName', 'Value': 'SFDC'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-01072614ee2302863'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-02556011f0f0e1e68',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 5, 5, 16, 52, 22, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-46.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.46',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 5, 5, 16, 52, 23, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-08b062dd7359137ad'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX30Role',
            'Id': 'AIPA5BKAMRUXNWKQPIKRK'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 5, 5, 16, 52, 22, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0979cc6a8c80af77d',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:50:62:32:e1:c4',
            'NetworkInterfaceId': 'eni-063104ffc4d2ef318',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-46.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.46',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-46.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.46'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Description', 'Value': 'EDA Team'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX30'},
            {'Key': 'aws:ec2launchtemplate:version', 'Value': '1'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'aws:ec2launchtemplate:id', 'Value': 'lt-0b178cb4e571af901'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0abf1cac7ad426df7'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0c586232d401c8218',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 6, 17, 18, 40, 43, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-195.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.195',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 6, 17, 18, 40, 44, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-09ec75fc09d740c18'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX31Role',
            'Id': 'AIPA5BKAMRUXAJ2RM67EL'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 6, 17, 18, 40, 43, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-08adccc01ca5d8bb3',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'sgCdmJumpBox',
                'GroupId': 'sg-00f8036baa667f8e1'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:02:3c:4b:e5:0a',
            'NetworkInterfaceId': 'eni-092c3346e4d295797',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-195.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.195',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-195.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.195'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'sgCdmJumpBox',
            'GroupId': 'sg-00f8036baa667f8e1'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'aws:ec2launchtemplate:id',
            'Value': 'lt-0b178cb4e571af901'},
            {'Key': 'aws:ec2launchtemplate:version', 'Value': '1'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'For Informatica Team'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX31'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0c34b6b09f05be8e1'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-03533523b029c7edc',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 7, 15, 22, 22, 43, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-14.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.14',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 7, 15, 22, 22, 44, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-04ce7d1c1dc380b5b'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX32Role',
            'Id': 'AIPA5BKAMRUXBLVPEGA24'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 7, 15, 22, 22, 43, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0ea23499570e10fd9',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:d1:fc:a6:1b:76',
            'NetworkInterfaceId': 'eni-06ba136c99f0c867d',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-14.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.14',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-14.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.14'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'ProjectName', 'Value': 'ACDM'},
            {'Key': 'Description', 'Value': 'Actuarial Data Lake Users'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX32'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Group', 'Value': 'JMP'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0fd5c6b3765b71d7a'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-030ce58c5750f8aff',
            'InstanceType': 't3.large',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 11, 5, 23, 19, 10, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-62.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.62',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 8, 7, 14, 19, 11, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-08b254276575f05d4'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX33Role',
            'Id': 'AIPA5BKAMRUXCFPXTSQFY'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 8, 7, 14, 19, 11, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0067fd5056bbad97e',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:bd:0a:eb:19:6d',
            'NetworkInterfaceId': 'eni-0ee38de92b4066314',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-62.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.62',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-62.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.62'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Description',
            'Value': "Actuarial Support - MIke's Team"},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'ProjectName', 'Value': 'ACDM'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX33'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-03dcdb08e35dc5590'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0b37f92ce183cf869',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 8, 25, 16, 6, 46, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-164.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.164',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 80, 'Name': 'stopped'},
            'StateTransitionReason': 'User initiated (2021-02-02 16:17:22 GMT)',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 8, 13, 22, 24, 21, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0122976e53b58589b'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX35Role',
            'Id': 'AIPA5BKAMRUXMVROTHSMN'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 8, 13, 22, 24, 20, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-00b1f26e8faf6b85b',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:12:e0:d2:e6:93',
            'NetworkInterfaceId': 'eni-083247574ba95300a',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-164.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.164',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-164.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.164'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'StateReason': {'Code': 'Client.UserInitiatedShutdown',
            'Message': 'Client.UserInitiatedShutdown: User initiated shutdown'},
            'Tags': [{'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX35'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Description', 'Value': 'Redshift POC - AWS Bhaskar'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0fdee2c3f5ba49b60'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0a563394ecc0a37f5',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 8, 18, 17, 44, 31, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-41.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.41',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 8, 13, 22, 29, 54, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-09bc1de15cae80881'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX34Role',
            'Id': 'AIPA5BKAMRUXP22YJ7NYH'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 8, 13, 22, 29, 53, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0235c9a49e57ddafa',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:25:f6:a5:08:83',
            'NetworkInterfaceId': 'eni-0cb7d18f439b49f3f',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-41.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.41',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-41.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.41'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX34'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'For EDA Team - Box 2'},
            {'Key': 'Group', 'Value': 'JMP'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0b13d380afe848433'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-00b8a557144fa2f18',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 9, 11, 16, 34, 15, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-103.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.103',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 8, 21, 4, 42, 5, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0ba692ac8a5bf75ca'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX36Role',
            'Id': 'AIPA5BKAMRUXPPM6GLBF2'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 8, 21, 4, 42, 4, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-095107c63c2f692ad',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:5a:44:d0:3a:c9',
            'NetworkInterfaceId': 'eni-0ba722b9e2c230d5e',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-103.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.103',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-103.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.103'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX36'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Description', 'Value': 'Actuarial Data Lake Users - 2'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'ProjectName', 'Value': 'ACDM'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0593973667629050a'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0faceac1aba8fc1ab',
            'InstanceType': 't3.large',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 11, 5, 23, 19, 21, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-125.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.125',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 10, 1, 18, 20, 13, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0f7ce32d17a37eb55'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX37Role',
            'Id': 'AIPA5BKAMRUXNWOKQG56E'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 10, 1, 18, 20, 12, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0502bef0e8536a0d5',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:6f:24:0c:3e:55',
            'NetworkInterfaceId': 'eni-0b7b0d90eda3c7a02',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-125.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.125',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-125.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.125'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'ProjectName', 'Value': 'ACDM'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX37'},
            {'Key': 'Description',
            'Value': "Actuarial Support - MIke's Team - Box2"},
            {'Key': 'Group', 'Value': 'JMP'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-003d89ed290aed76e'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 1,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-083511032c23936da',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 10, 20, 18, 27, 15, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-225.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.225',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 10, 19, 13, 52, 27, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0823bf90d3a83147d'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX39Role',
            'Id': 'AIPA5BKAMRUXA625DPDNX'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 10, 19, 13, 52, 26, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-072ad293f3eb6c8e2',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:df:c6:07:ef:89',
            'NetworkInterfaceId': 'eni-007d6d8e77c9b7b82',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-225.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.225',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-225.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.225'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'ProjectName', 'Value': 'Resonant'},
            {'Key': 'CostTracking', 'Value': 'Resonant'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX39'},
            {'Key': 'Environment', 'Value': 'Dev'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Description', 'Value': 'Resonant Dev Team - Keste Onsite 2'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-078377da26f34a961',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 10, 20, 18, 27, 15, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-238.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.238',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 10, 19, 13, 52, 27, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-08031eb5959b8de18'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX38Role',
            'Id': 'AIPA5BKAMRUXCCOP5XSC2'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 10, 19, 13, 52, 26, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-08a5fce0e0174f763',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:63:c3:f6:93:83',
            'NetworkInterfaceId': 'eni-07f051ca290885c73',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-238.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.238',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-238.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.238'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Environment', 'Value': 'Dev'},
            {'Key': 'CostTracking', 'Value': 'Resonant'},
            {'Key': 'ProjectName', 'Value': 'Resonant'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX38'},
            {'Key': 'Description', 'Value': 'Resonant Dev Team - Keste Onsite 1'},
            {'Key': 'Group', 'Value': 'JMP'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-09f92fe306484e109'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0562d77b6710a0ff1',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 10, 20, 18, 27, 15, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-51.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.51',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 10, 20, 2, 36, 49, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0e2b6400ad7b9fdd1'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX40Role',
            'Id': 'AIPA5BKAMRUXGPZCTA77Y'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 10, 20, 2, 36, 48, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0abf2d2b80ae24ff4',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:23:0d:e9:19:6b',
            'NetworkInterfaceId': 'eni-08397288819adcf25',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-51.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.51',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-51.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.51'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'Resonant'},
            {'Key': 'ProjectName', 'Value': 'Resonant'},
            {'Key': 'Environment', 'Value': 'Dev'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX40'},
            {'Key': 'Description', 'Value': 'Resonant Dev Team - Keste Offshore 2'},
            {'Key': 'Group', 'Value': 'JMP'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0d12e38e8f5e6ef7b'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-07b0f0dec2edcc673',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 10, 22, 16, 0, 5, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-18.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.18',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 10, 22, 16, 0, 6, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0a5bb3420cd90ef45'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX41Role',
            'Id': 'AIPA5BKAMRUXHMQVYUVRF'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 10, 22, 16, 0, 5, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0a68c70ba135f0863',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:88:34:81:cf:29',
            'NetworkInterfaceId': 'eni-0bd346cf4c1b35720',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-18.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.18',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-18.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.18'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX41'},
            {'Key': 'Project', 'Value': 'Resonant'},
            {'Key': 'CostTracking', 'Value': 'Resonant'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Environment', 'Value': 'Dev'},
            {'Key': 'Description', 'Value': 'Resonant Dev Team - Keste Offshore 2'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-062def1fa10b97e37'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0bc731bbbfcd431b1',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 31, 20, 15, 57, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-91.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.91',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 10, 29, 16, 0, 44, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0cd4a2627f28d5d5e'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX42Role',
            'Id': 'AIPA5BKAMRUXFMN53JYTL'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 10, 29, 16, 0, 43, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-07df086990cd0e92e',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:fd:b3:36:63:79',
            'NetworkInterfaceId': 'eni-01d8198a282dfa12e',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-91.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.91',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-91.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.91'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Description',
            'Value': 'Resonant Dev Team - SA - Anthony'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX42'},
            {'Key': 'ProjectName', 'Value': 'Resonant'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Environment', 'Value': 'Dev'},
            {'Key': 'CostTracking', 'Value': 'Resonant'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-05992c41b9ec1e3f1'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-07f670514e8c164c9',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 11, 13, 0, 19, 14, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-35.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.35',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 11, 9, 23, 37, 1, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0ceefd77ebb69d73a'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX43Role',
            'Id': 'AIPA5BKAMRUXGG5YSHIFE'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 11, 9, 23, 37, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0fe3eb40e04cfa4f2',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:b1:c1:d2:fc:c1',
            'NetworkInterfaceId': 'eni-04a9be3dfd3bf0fb8',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-35.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.35',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-35.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.35'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX43'},
            {'Key': 'Description',
            'Value': 'RG_DirectResponseMarketing_DataLake_Users(Jeff, Leslie)'},
            {'Key': 'Environment', 'Value': 'dev'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'ProjectName', 'Value': 'SFDC'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-06b0e013897140f70'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0fb76e8152c10c5e8',
            'InstanceType': 't3.large',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 11, 13, 0, 19, 14, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-55.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.55',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 11, 9, 23, 39, 58, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-01dbcbf434d3212bd'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX44Role',
            'Id': 'AIPA5BKAMRUXFBYHVPFH7'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 11, 9, 23, 39, 57, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0d8d3c1628724c0c6',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:e2:d8:e2:8d:37',
            'NetworkInterfaceId': 'eni-06f0eccf0176e917b',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-55.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.55',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-55.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.55'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX44'},
            {'Key': 'ProjectName', 'Value': 'ACDM'},
            {'Key': 'CostTracking', 'Value': 'ACDM'},
            {'Key': 'Description', 'Value': 'Actuarial Support 3'},
            {'Key': 'Environment', 'Value': 'dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-06be4a4fd0779ee62'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0c39e554fda54feaa',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 12, 8, 4, 12, 23, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-196.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.196',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 12, 3, 3, 19, 9, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-082890933199ef161'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX45Role',
            'Id': 'AIPA5BKAMRUXMB5FLYMOM'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 12, 3, 3, 19, 8, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0501c1bd6b4b922c2',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:de:9c:09:b3:f7',
            'NetworkInterfaceId': 'eni-0677e8fdc71c557f2',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-196.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.196',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-196.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.196'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Environment', 'Value': 'Dev'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX45'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'Data Lake UCT Team'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0ba53f9fe98c2c7fc'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-01cb7fe23115df97a',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 12, 8, 4, 12, 23, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-54.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.54',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 12, 3, 23, 7, 39, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0b276d73f24d72f0e'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX46Role',
            'Id': 'AIPA5BKAMRUXCCXV7PGN5'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 12, 3, 23, 7, 38, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0a07f997ef598ea70',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:2e:92:f0:a4:3f',
            'NetworkInterfaceId': 'eni-0da84d7b13695ddb7',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-54.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.54',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-54.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.54'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'PAS'},
            {'Key': 'ProjectName', 'Value': 'PAS-ODS'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX46'},
            {'Key': 'Description', 'Value': 'PAS ODS Aurora POC'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0b4726d3924a138ff'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-01f661b096aa7a6bc',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2020, 12, 8, 4, 12, 23, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-11.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.11',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2020, 12, 3, 23, 14, 11, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0bdefcf0c564b7791'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX47Role',
            'Id': 'AIPA5BKAMRUXCWQOFCR27'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2020, 12, 3, 23, 14, 10, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-025c893b0e4eca481',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:ed:fe:e9:05:91',
            'NetworkInterfaceId': 'eni-04712126d6296caf1',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-11.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.11',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-11.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.11'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'ProjectName', 'Value': 'PAS-ODS'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX47'},
            {'Key': 'CostTracking', 'Value': 'PAS'},
            {'Key': 'Description', 'Value': 'PAS ODS Aurora POC'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0134d8cefc18df65a'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0d967a7a176ea4457',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 15, 15, 36, 36, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-149.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.149',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 12, 1, 9, 27, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0f11d8a3b73d7a369'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX48Role',
            'Id': 'AIPA5BKAMRUXFOLIOZHV7'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 12, 1, 9, 26, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-04457592da0020982',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:bf:ca:81:dc:ff',
            'NetworkInterfaceId': 'eni-09354b90be1de4a2a',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-149.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.149',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-149.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.149'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX48'},
            {'Key': 'Environment', 'Value': 'Dev'},
            {'Key': 'CostTracking', 'Value': 'Resonant'},
            {'Key': 'ProjectName', 'Value': 'Resonant'},
            {'Key': 'Description',
            'Value': 'Resonant FTE- Integration and Data Team'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0cbdbfd6dbc9fc8a9'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 1,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-01c4276a3bbb3d41a',
            'InstanceType': 't3.small',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-72.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.72',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-043b15d54be2d6298'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX49Role',
            'Id': 'AIPA5BKAMRUXAEUBXFGIW'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-03e46e4d8bcef42dc',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:4a:24:d4:c7:77',
            'NetworkInterfaceId': 'eni-02b3bd7b5da069dc6',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-72.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.72',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-72.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.72'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Description', 'Value': 'PAS ODS Aurora POC'},
            {'Key': 'ProjectName', 'Value': 'PAS-ODS'},
            {'Key': 'CostTracking', 'Value': 'PAS'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX49'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0ccd2cdd0d768e981',
            'InstanceType': 't3.small',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-153.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.153',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-02646c3095c0dd5af'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX50Role',
            'Id': 'AIPA5BKAMRUXCAGTDRYER'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0093c3c448976d46a',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:6c:61:29:18:a9',
            'NetworkInterfaceId': 'eni-02ef434df99c98f07',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-153.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.153',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-153.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.153'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'PAS'},
            {'Key': 'Description', 'Value': 'PAS ODS Aurora POC'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX50'},
            {'Key': 'ProjectName', 'Value': 'PAS-ODS'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 3,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0eede5c37cd3b9e14',
            'InstanceType': 't3.small',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-174.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.174',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0c2ad135d9e8d72a6'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX51Role',
            'Id': 'AIPA5BKAMRUXN2UTGNJV7'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0e15ecd67afb1c066',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:d8:87:24:18:79',
            'NetworkInterfaceId': 'eni-0ee0163aa11c78893',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-174.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.174',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-174.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.174'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'ProjectName', 'Value': 'PAS-ODS'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX51'},
            {'Key': 'CostTracking', 'Value': 'PAS'},
            {'Key': 'Description', 'Value': 'PAS ODS Aurora POC'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 2,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-093c6b0d80b13fc7a',
            'InstanceType': 't3.small',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-75.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.75',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0d34fbdce40ab36e7'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX52Role',
            'Id': 'AIPA5BKAMRUXJPII6O3JF'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0bdc5359b26221047',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:28:5c:fe:bf:df',
            'NetworkInterfaceId': 'eni-09ce028200311f3ec',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-75.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.75',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-75.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.75'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'PAS'},
            {'Key': 'Description', 'Value': 'PAS ODS Aurora POC'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX52'},
            {'Key': 'ProjectName', 'Value': 'PAS-ODS'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 5,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0f366f60099c9f97d',
            'InstanceType': 't3.small',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 21, 4, 57, 35, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-80.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.80',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-01bfea9dbe4c0050d'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX53Role',
            'Id': 'AIPA5BKAMRUXDCVSRR2KG'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-08a8869cfc178e273',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:e3:7a:bc:57:7d',
            'NetworkInterfaceId': 'eni-04e1ec424b2023c33',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-80.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.80',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-80.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.80'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Description',
            'Value': 'Resonant Data Integration Offshore'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX53'},
            {'Key': 'ProjectName', 'Value': 'Resonant'},
            {'Key': 'CostTracking', 'Value': 'Resonant'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 4,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0990bc60bbf15569b',
            'InstanceType': 't3.small',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 21, 4, 57, 35, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-209.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.209',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-05bdc91c5acc4f733'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX54Role',
            'Id': 'AIPA5BKAMRUXE3SAK5TGO'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-02517d9b92b6910ba',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:ab:42:21:d7:29',
            'NetworkInterfaceId': 'eni-0866bafb43532cc29',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-209.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.209',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-209.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.209'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Description',
            'Value': 'Resonant Data Integration Offshore'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX54'},
            {'Key': 'ProjectName', 'Value': 'Resonant'},
            {'Key': 'CostTracking', 'Value': 'Resonant'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 6,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-04d384aebf14d3a5a',
            'InstanceType': 't3.small',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 22, 5, 21, 15, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-242.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.242',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 18, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0883338ce5869f7fa'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX55Role',
            'Id': 'AIPA5BKAMRUXJN3CDJXMJ'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 14, 20, 30, 17, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0562c9dc3c20ec1c8',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:39:2c:b4:1d:cf',
            'NetworkInterfaceId': 'eni-06cddbd36dd9cd4d7',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-242.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.242',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-242.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.242'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX55'},
            {'Key': 'ProjectName', 'Value': 'PAS-ODS'},
            {'Key': 'Description', 'Value': 'PAS ODS Aurora POC'},
            {'Key': 'CostTracking', 'Value': 'PAS'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-01818400efa4bf5a9'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 1,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-056cd8d3d716d2f1b',
            'InstanceType': 't3.small',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 22, 5, 21, 15, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-215.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.215',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 21, 5, 1, 47, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0db96140429927aac'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX56Role',
            'Id': 'AIPA5BKAMRUXHV5GPKYPC'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 21, 5, 1, 46, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-068837e43e7b97c31',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:34:8a:85:37:f3',
            'NetworkInterfaceId': 'eni-0bfe52fce278b55e3',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-215.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.215',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-215.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.215'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'PAS'},
            {'Key': 'Description', 'Value': 'PAS ODS Aurora POC'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX56'},
            {'Key': 'ProjectName', 'Value': 'PAS-ODS'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-00b9ed1ba52c6be5d',
            'InstanceType': 't3.small',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 1, 22, 5, 21, 15, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-136.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.136',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 1, 21, 5, 1, 47, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0e140ce84a73d1a07'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX57Role',
            'Id': 'AIPA5BKAMRUXE4LMFUDKY'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 1, 21, 5, 1, 46, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0c6e3fffd6f01eac5',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:6d:05:ad:7d:b7',
            'NetworkInterfaceId': 'eni-033d23ffe696c36d4',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-136.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.136',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-136.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.136'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX57'},
            {'Key': 'CostTracking', 'Value': 'PAS'},
            {'Key': 'Description', 'Value': 'PAS ODS Aurora POC'},
            {'Key': 'ProjectName', 'Value': 'PAS-ODS'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0e99489b33aef7fb2'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-07d4d26f8c90cb121',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 3, 30, 19, 23, 55, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'enabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-234.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.234',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 3, 30, 18, 35, 21, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0620a49f9be626526'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX58Role',
            'Id': 'AIPA5BKAMRUXO4QKI2IWC'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 3, 30, 18, 35, 20, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-03fb9377c3d4221cd',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': '',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:ba:57:a3:06:3d',
            'NetworkInterfaceId': 'eni-049a44ab8ce47274a',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-234.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.234',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-234.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.234'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Description', 'Value': 'Data Lake Team'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX58'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Project', 'Value': 'CDM'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-01de0fd87e1221c5f'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-06bd4f967e21d2652',
            'InstanceType': 't3.medium',
            'KeyName': 'CdmDev',
            'LaunchTime': datetime.datetime(2021, 5, 11, 1, 46, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-65.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.65',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 5, 11, 1, 46, 1, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0d6895fc58cd93f7c'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX59Role',
            'Id': 'AIPA5BKAMRUXAGULKCR7F'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 5, 11, 1, 46, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0dd822f04013ffe8c',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:26:50:40:8b:d7',
            'NetworkInterfaceId': 'eni-0b6a52b9815e241f7',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-65.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.65',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-65.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.65'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Description', 'Value': 'Actuarial Support 4'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX59'},
            {'Key': 'CostTracking', 'Value': 'CDM'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0526140c541bee1d5'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0e1849110e15028ea',
            'InstanceType': 't3.medium',
            'KeyName': 'CDM_Dev_CloudOps',
            'LaunchTime': datetime.datetime(2021, 5, 27, 16, 42, 31, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-76.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.76',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 5, 27, 16, 42, 32, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0a3e93a51423fa47d'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX60Role',
            'Id': 'AIPA5BKAMRUXK2Q5AHGPA'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 5, 27, 16, 42, 31, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0a769b5f0d5abebb7',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:6d:6c:f4:56:bf',
            'NetworkInterfaceId': 'eni-0c1879f0d465ba167',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-76.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.76',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-76.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.76'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'Actuarial Support 5'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX60'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-09413b18b203596c6'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-09563dbee3de6bcdb',
            'InstanceType': 't3.medium',
            'KeyName': 'CDM_Dev_CloudOps',
            'LaunchTime': datetime.datetime(2021, 5, 27, 16, 44, 1, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-121.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.121',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 5, 27, 16, 44, 2, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-09af08050cda26dc0'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX61Role',
            'Id': 'AIPA5BKAMRUXEESMIO57U'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 5, 27, 16, 44, 1, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0bd0378c8008d866d',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:d4:78:84:4c:f7',
            'NetworkInterfaceId': 'eni-0b99dedd1aa77fb04',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-121.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.121',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-121.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.121'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX61'},
            {'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Description', 'Value': 'Actuarial Support 6'},
            {'Key': 'Group', 'Value': 'JMP'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0d244ead8e9d556a5'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 2,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0455a3cbab51e4fbf',
            'InstanceType': 't3.medium',
            'KeyName': 'CDM_Dev_CloudOps',
            'LaunchTime': datetime.datetime(2021, 8, 2, 21, 33, 48, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-134.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.134',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 80, 'Name': 'stopped'},
            'StateTransitionReason': 'User initiated (2021-08-27 15:07:27 GMT)',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 8, 2, 21, 33, 49, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-08eeff55a6c24ecf1'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX62Role',
            'Id': 'AIPA5BKAMRUXJQ4MWPPOB'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 8, 2, 21, 33, 48, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-09fbb3fc318888548',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:40:a1:57:2e:83',
            'NetworkInterfaceId': 'eni-07e39ea574e236922',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-134.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.134',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-134.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.134'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'StateReason': {'Code': 'Client.UserInitiatedShutdown',
            'Message': 'Client.UserInitiatedShutdown: User initiated shutdown'},
            'Tags': [{'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Description', 'Value': 'Resonant BA QA Team'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX62'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 1,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0535e58fd359123bb',
            'InstanceType': 't3.medium',
            'KeyName': 'CDM_Dev_CloudOps',
            'LaunchTime': datetime.datetime(2021, 8, 2, 21, 33, 48, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-94.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.94',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 80, 'Name': 'stopped'},
            'StateTransitionReason': 'User initiated (2021-08-27 15:07:32 GMT)',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 8, 2, 21, 33, 49, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-0d1cdf2a7a939f97f'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX63Role',
            'Id': 'AIPA5BKAMRUXJYNSWKM2C'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 8, 2, 21, 33, 48, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-0f7cccf4f93350909',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:e7:d1:84:60:65',
            'NetworkInterfaceId': 'eni-02575a85a0e412134',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-94.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.94',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-94.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.94'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'StateReason': {'Code': 'Client.UserInitiatedShutdown',
            'Message': 'Client.UserInitiatedShutdown: User initiated shutdown'},
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX63'},
            {'Key': 'Description', 'Value': 'Resonant BA QA Team'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'awsbackup', 'Value': 'Dev'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}},
            {'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-0aa9ed467c1c59bdd',
            'InstanceType': 't3.medium',
            'KeyName': 'CDM_Dev_CloudOps',
            'LaunchTime': datetime.datetime(2021, 8, 2, 21, 33, 48, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-79.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.79',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 80, 'Name': 'stopped'},
            'StateTransitionReason': 'User initiated (2021-08-27 15:07:38 GMT)',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 8, 2, 21, 33, 49, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-08e13a5bbfb133fec'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX64Role',
            'Id': 'AIPA5BKAMRUXLKBWPHWQ6'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 8, 2, 21, 33, 48, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-08478181f6d031b6c',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:1c:0b:6c:6e:39',
            'NetworkInterfaceId': 'eni-078613bfebdfb54ff',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-79.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.79',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-79.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.79'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'StateReason': {'Code': 'Client.UserInitiatedShutdown',
            'Message': 'Client.UserInitiatedShutdown: User initiated shutdown'},
            'Tags': [{'Key': 'awsbackup', 'Value': 'Dev'},
            {'Key': 'Group', 'Value': 'JMP'},
            {'Key': 'CostTracking', 'Value': 'CDM'},
            {'Key': 'Name', 'Value': 'AWTCDMDJMPBOX64'},
            {'Key': 'Description', 'Value': 'Resonant BA QA Team'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-086565b70a86bed20'},
        {'Groups': [],
        'Instances': [{'AmiLaunchIndex': 0,
            'ImageId': 'ami-02bb3bed897e303d7',
            'InstanceId': 'i-06d437f18c48cf351',
            'InstanceType': 't3.medium',
            'KeyName': 'CDM_Dev_CloudOps',
            'LaunchTime': datetime.datetime(2021, 9, 30, 16, 17, 23, tzinfo=datetime.timezone.utc),
            'Monitoring': {'State': 'disabled'},
            'Placement': {'AvailabilityZone': 'us-west-2c',
            'GroupName': '',
            'Tenancy': 'default'},
            'Platform': 'windows',
            'PrivateDnsName': 'ip-10-182-254-141.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.141',
            'ProductCodes': [],
            'PublicDnsName': '',
            'State': {'Code': 16, 'Name': 'running'},
            'StateTransitionReason': '',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'Architecture': 'x86_64',
            'BlockDeviceMappings': [{'DeviceName': '/dev/sda1',
            'Ebs': {'AttachTime': datetime.datetime(2021, 9, 30, 16, 17, 24, tzinfo=datetime.timezone.utc),
                'DeleteOnTermination': True,
                'Status': 'attached',
                'VolumeId': 'vol-01858f8db03f19575'}}],
            'ClientToken': '',
            'EbsOptimized': True,
            'EnaSupport': True,
            'Hypervisor': 'xen',
            'IamInstanceProfile': {'Arn': 'arn:aws:iam::896172592430:instance-profile/AWTCDMDJMPBOX65Role',
            'Id': 'AIPA5BKAMRUXLDF5E3PAG'},
            'NetworkInterfaces': [{'Attachment': {'AttachTime': datetime.datetime(2021, 9, 30, 16, 17, 23, tzinfo=datetime.timezone.utc),
                'AttachmentId': 'eni-attach-00ad495dce77619f4',
                'DeleteOnTermination': True,
                'DeviceIndex': 0,
                'Status': 'attached',
                'NetworkCardIndex': 0},
            'Description': 'Primary network interface',
            'Groups': [{'GroupName': 'EC2_win_workbench',
                'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'Ipv6Addresses': [],
            'MacAddress': '0a:d7:8e:c8:e4:77',
            'NetworkInterfaceId': 'eni-08c6fd332dc3db7be',
            'OwnerId': '896172592430',
            'PrivateDnsName': 'ip-10-182-254-141.us-west-2.compute.internal',
            'PrivateIpAddress': '10.182.254.141',
            'PrivateIpAddresses': [{'Primary': True,
                'PrivateDnsName': 'ip-10-182-254-141.us-west-2.compute.internal',
                'PrivateIpAddress': '10.182.254.141'}],
            'SourceDestCheck': True,
            'Status': 'in-use',
            'SubnetId': 'subnet-0b2749160ea474a0c',
            'VpcId': 'vpc-0025c7eb2ebad4f1e',
            'InterfaceType': 'interface'}],
            'RootDeviceName': '/dev/sda1',
            'RootDeviceType': 'ebs',
            'SecurityGroups': [{'GroupName': 'EC2_win_workbench',
            'GroupId': 'sg-0052c8cf0cf6aeb88'}],
            'SourceDestCheck': True,
            'Tags': [{'Key': 'Name', 'Value': 'AWTCDMDJMPBOX65'}],
            'VirtualizationType': 'hvm',
            'CpuOptions': {'CoreCount': 1, 'ThreadsPerCore': 2},
            'CapacityReservationSpecification': {'CapacityReservationPreference': 'open'},
            'HibernationOptions': {'Configured': False},
            'MetadataOptions': {'State': 'applied',
            'HttpTokens': 'optional',
            'HttpPutResponseHopLimit': 1,
            'HttpEndpoint': 'enabled'},
            'EnclaveOptions': {'Enabled': False}}],
        'OwnerId': '896172592430',
        'ReservationId': 'r-0139dda942d048ca6'}],
        'ResponseMetadata': {'RequestId': '8e21ea79-f977-43d9-a5fe-f9d8b732dbc7',
        'HTTPStatusCode': 200,
        'HTTPHeaders': {'x-amzn-requestid': '8e21ea79-f977-43d9-a5fe-f9d8b732dbc7',
        'cache-control': 'no-cache, no-store',
        'strict-transport-security': 'max-age=31536000; includeSubDomains',
        'vary': 'accept-encoding',
        'content-type': 'text/xml;charset=UTF-8',
        'transfer-encoding': 'chunked',
        'date': 'Fri, 15 Oct 2021 14:37:13 GMT',
        'server': 'AmazonEC2'},
        'RetryAttempts': 0}}

    @staticmethod
    def describe_subnets():
        return {
            'Subnets': [
                {'SubnetId': 'SubnetId1'},
                {'SubnetId': 'SubnetId2'},
                {'SubnetId': 'SubnetId3'},
                {'SubnetId': 'SubnetIdN'},
            ],
        }

    @staticmethod
    def terminate_instances(InstanceIds):
        for instance_id in InstanceIds:
            return {
                'TerminatingInstances': [
                    {
                        'CurrentState': {
                            'Name': 'shutting-down'
                        },
                        'InstanceId': instance_id,
                        'PreviousState': {
                            'Name': 'running'
                        }
                    },
                ]
            }

    @staticmethod
    def stop_instances(InstanceIds):
        return {
            'StoppingInstances': [
                {
                    'CurrentState': {
                        'Code': 123,
                        'Name': 'stopping'
                    },
                    'InstanceId': instance_id,
                    'PreviousState': {
                        'Code': 123,
                        'Name': 'running'
                    }
                } for instance_id in InstanceIds
            ]
        }

    @staticmethod
    def run_instances(ImageId, InstanceType,  IamInstanceProfile, KeyName, SubnetId, TagSpecifications, **kwargs):
        key = list("1234567890abcdef0")
        random.shuffle(key)
        availability_zone = random.choice(["ZoneA", "ZoneB", "ZoneC", "ZoneD"])
        return {
            'Instances': [
                {
                    'ImageId': ImageId,
                    'InstanceId': f"i-{''.join(key)}",
                    'InstanceType': InstanceType,
                    'KeyName': KeyName,
                    'Placement': {
                        'AvailabilityZone': availability_zone,
                    },
                    'State': {
                        'Name': 'running'
                    },
                    'SubnetId': SubnetId,
                    'IamInstanceProfile': {'Arn': IamInstanceProfile["Arn"]},
                    'StateReason': {
                        'Code': 'string',
                        'Message': 'string'
                    },
                    'TagSpecifications': TagSpecifications,
                },
            ],
        }

    class exceptions:
        class ClientError(Exception):
            pass
